#!/usr/local/bin/bash
#
# Copyright (C) 2004 SIPfoundry Inc.
# Licensed by SIPfoundry under the LGPL license.
#
# Copyright (C) 2004 Pingtel Corp.
# Licensed to SIPfoundry under a Contributor Agreement.

Action=RUN
Status=0
Args=""

while [ $# -ne 0 ]
do
    case ${1} in
        --configtest)
            Action=CONFIGTEST
            ;;

        *)
            Args="$Args $1"
            ;;
    esac           

    shift # always consume 1
done

CONFIG_DEFS="/usr/local/etc/sipxpbx/config.defs"

CONFIG_FILES="\
  /usr/local/etc/sipxpbx/mediaserver-config \
  /usr/local/etc/sipxpbx/voicemail.xml \
  "

# If the "config.defs" file exists and the <name>.in file exists for a
# configuration file, then run the config preprocessor to generate the
# fully resolved configuration file.
if [ -f "$CONFIG_DEFS" ]
then
  for i in $CONFIG_FILES ; do
    if [ -f "${i}.in" ]
    then
       /usr/local/bin/configpp --defs "${CONFIG_DEFS}" --in "${i}.in" --out "$i"
    fi
  done


  # run the config preprocessor over the voicexml scripts
  for cfgfile in /usr/local/www/sipX/doc/aa_vxml/*.in /usr/local/www/sipX/doc/vm_vxml/*.in 
  do
    if [ -f ${cfgfile} ]
    then
       genfile=`basename ${cfgfile} .in`
       gendir=`dirname ${cfgfile}`
       genout="${gendir}/${genfile}"
       rm -f ${genout}
       /usr/local/bin/configpp --defs "${CONFIG_DEFS}" --in "${cfgfile}" --out "${genout}"
    fi
  done
fi

case ${Action} in
   RUN)
     # Create the voicemail directories if they do not already exist.
     mkdir -p /var/sipxdata/mediaserver/data/autoattendant/ui/adminui
     mkdir -p /var/sipxdata/mediaserver/data/autoattendant/vxml
     mkdir -p /var/sipxdata/mediaserver/data/mailstore
     mkdir -p /var/sipxdata/mediaserver/data/prompts
     mkdir -p /var/sipxdata/mediaserver/data/voicemail/ui/adminui
     mkdir -p /var/sipxdata/mediaserver/data/voicemail/vxml

     echo $$ > /var/run/sipxpbx/sipXvxml.pid
     exec /usr/local/bin/sipXvxml $Args
     ;;

   CONFIGTEST)
     #/usr/local/bin/sipx-validate-xml /usr/local/etc/sipxpbx/?.xml
     #Status=$(($Status+$?))
     ;;
esac

exit $Status
